<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'StagesTable',
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      selectedTab: 'plan',
    };
  },
  mounted() {},
  methods: {
    onTabSelect(value: string) {
      this.selectedTab = value;
      this.scrollToTop();
    },
    scrollToTop() {
      const table = document.querySelector('.stages-table__table') as any;
      const stages = (
        document.querySelector('.stages-table__table__stages') as any
      ).getBoundingClientRect().height;
      if (window)
        window.scrollTo({
          top: table.offsetTop - stages,
          behavior: 'smooth',
        });
    },
  },
});
</script>

<template>
  <div class="stages-table">
    <SlpRow class="stages-table__heading">
      <SlpColumn :cols="10" size="md">
        <SlpTypography tag="h1" variant="heading2-bold" class="slp-pb-32">{{
          data.headline
        }}</SlpTypography>
        <SlpTypography tag="h5" variant="heading5">{{
          data.description
        }}</SlpTypography>
      </SlpColumn>
    </SlpRow>
    <div class="stages-table__table-wrapper">
      <table class="stages-table__table">
        <thead class="stages-table__table__stages">
          <tr>
            <th colspan="11" class="stages-table__blocker">
              <div class="stages-table__blocker__div"></div>
            </th>
          </tr>
          <tr>
            <th></th>
            <th v-for="(stage, stageIndex) in data.tabs" :key="stageIndex">
              <div
                class="stages-table__table__cell stages-table__stage"
                :class="{
                  'stages-table__stage--active': stage.text === selectedTab,
                }"
                @click="onTabSelect(stage.text)"
              >
                <SlpIcon
                  class="icon"
                  :name="stage.icon.name"
                  variant="marketing"
                  size="md"
                />
                <SlpTypography
                  variant="body2"
                  class="slp-pt-16 stages-table__stage-name"
                  >{{ stage.text }}</SlpTypography
                >
              </div>
            </th>
          </tr>
        </thead>
        <tbody class="stages-table__table__body">
          <tr
            v-for="(competitor, index) in data.competitors"
            :key="index"
            class="stages-table__competitor"
            :class="{
              'stages-table__main-competitor': competitor.main_competitor,
            }"
          >
            <td class="stages-table__logo">
              <div class="stages-table__img">
                <a :href="competitor.href">
                  <nuxt-img
                    :src="competitor.logo"
                    :alt="competitor.logo_alt ? competitor.logo_alt : ''"
                    loading="lazy"
                  />
                </a>
              </div>
            </td>
            <td class="stages-table__cell-mobile">
              <div class="stages-table__icon">
                <SlpIcon
                  v-if="competitor.stages.includes(selectedTab)"
                  class="icon"
                  name="check"
                  variant="product"
                  size="md"
                />
              </div>
            </td>
            <td
              v-for="stage in data.tabs"
              :key="stage.text"
              class="stages-table__cell-desktop"
            >
              <div class="stages-table__table__cell">
                <div class="stages-table__icon">
                  <SlpIcon
                    v-if="competitor.stages.includes(stage.text)"
                    class="icon"
                    name="check"
                    variant="product"
                    size="md"
                  />
                </div>
              </div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <SlpRow class="stages-table__disclaimer">
      <SlpColumn :cols="8" size="md">
        <SlpTypography tag="p" variant="body3">{{
          data.disclaimer.intro
        }}</SlpTypography>
        <SlpTypography
          tag="p"
          variant="body3"
          class="slp-pt-24 stages-table__italic"
          >{{ data.disclaimer.legend }}</SlpTypography
        >
      </SlpColumn>
    </SlpRow>
  </div>
</template>

<style lang="scss" scoped>
.stages-table {
  table,
  th,
  td {
    border-spacing: 0px;
    -webkit-border-horizontal-spacing: 0px;
    padding: 0;
  }

  &__table {
    width: 100%;
    margin: 0 auto;
    height: 100%;
    display: block;
    border-radius: 0 0 4px 4px;
    box-shadow: 0px 8px 50px -16px $color-primary-100;

    @media (min-width: $breakpoint-md) {
      height: 100%;
      overflow: initial;
      display: table;
      box-shadow: 0px 8px 50px -16px $color-primary-100;
    }

    &__stages-wrapper {
      display: flex;
    }

    &__stages {
      display: flex;
      overflow: scroll;
      position: sticky;
      top: 116px;
      z-index: 1;
      box-shadow: 0px 8px 50px 20px $color-primary-300;
      @media (min-width: $breakpoint-sm) {
        top: 80px;
      }
      @media (min-width: $breakpoint-md) {
        top: 96px;
        display: table-header-group;
        box-shadow: none;
      }
      @media (min-width: $breakpoint-lg) {
        top: 136px;
      }

      th {
        background: $color-secondary-200;
        position: relative;
        &::before {
          content: '';
          position: absolute;
          height: 100%;
          width: 100%;
          display: block;
          left: 0;
          bottom: 0;
          box-shadow: 0px 8px 50px $color-primary-100;
        }
        &:after {
          @media (min-width: $breakpoint-md) {
            content: '';
            position: absolute;
            height: 100%;
            width: 1px;
            display: block;
            right: -1px;
            bottom: 0;
            background: $color-secondary-200;
          }
        }
        &:nth-child(2) {
          border-top-left-radius: 4px;
          .stages-table__stage {
            border-top-left-radius: 4px;
          }
          &::before {
            border-top-left-radius: 4px;
          }
        }
        &:last-of-type {
          border-top-right-radius: 4px;
          .stages-table__stage {
            border-top-right-radius: 4px;
          }
          &::before {
            border-top-right-radius: 4px;
          }
          &::after {
            display: none;
          }
        }
        &:last-of-type,
        &:first-of-type {
          border-right: 0px solid transparent;
        }
        &:first-of-type {
          display: none;
          @media (min-width: $breakpoint-md) {
            display: table-cell;
            background: $color-secondary-200;
            position: initial;
          }
          &:before {
            display: none;
          }
        }
        @media (min-width: $breakpoint-md) {
          border-right: rgb(209 208 211 / 35%) solid 1px;
        }
      }
    }

    &__cell {
      padding: $spacing-16;
      display: flex;
      justify-content: center;
      flex-wrap: wrap;
      flex-direction: column;
      align-items: center;
      position: relative;
      @media (min-width: $breakpoint-md) {
        padding: $spacing-8;
      }
      @media (min-width: $breakpoint-lg) {
        padding: $spacing-16;
      }
      :deep span {
        font-weight: 600;
        @media (min-width: $breakpoint-md) {
          font-weight: 400;
        }
      }

      .stages-table__table__stages & {
        z-index: 1;
        background: $color-secondary-200;
      }
    }

    &__body {
      position: relative;
      background: $color-secondary-200;
      width: 100%;
      margin: 0 auto;
      height: auto;
      display: block;
      @media (min-width: $breakpoint-md) {
        display: table-row-group;
        border-radius: 0 0 4px 4px;
      }
      tr:nth-child(even) {
        background-color: rgb(242 241 245 / 35%);
      }
      td {
        border-right: rgb(209 208 211 / 35%) solid 1px;
        &:last-of-type {
          border-right: 0px solid transparent;
        }
      }
    }
  }

  &__img {
    display: flex;
    align-items: center;
    justify-content: center;
    padding: $spacing-8;
    height: 100%;
    position: relative;
    .stages-table__main-competitor & {
      img {
        height: 50px;
      }
    }
  }

  &__main-competitor {
    position: sticky;
    top: 230px;
    background: $color-secondary-200;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.1);
    border: 1px solid $color-surface-100;
    border-bottom: 0px;
    border-radius: 4px 4px 0px 0px;
    z-index: 2;
    @media (min-width: $breakpoint-sm) {
      top: 192px;
    }
    @media (min-width: $breakpoint-md) {
      border: 0px;
      border-radius: 0px;
      box-shadow: none;
      z-index: 1;
      top: 180px;
    }
    @media (min-width: $breakpoint-lg) {
      top: 236px;
    }

    td {
      @media (min-width: $breakpoint-md) {
        position: relative;
        &::before {
          content: '';
          position: absolute;
          height: 100%;
          width: 100%;
          display: block;
          left: 0;
          bottom: 0;
          background: $color-secondary-200;
        }
        &:first-of-type {
          position: relative;
          &::before {
            content: '';
            position: absolute;
            height: 100%;
            width: 100%;
            display: block;
            left: 0;
            bottom: 0;
            box-shadow: -6px -6px 20px rgb(209 208 211 / 34%);
            border-top-left-radius: 4px;
          }
        }
        &:last-of-type {
          position: initial;
          &::after {
            content: '';
            position: absolute;
            height: $spacing-8;
            width: 100%;
            display: block;
            left: 0;
            bottom: 0;
            box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.1);
          }
          &::before {
            display: none;
          }
        }
      }
    }
  }

  &__competitor {
    height: 64px;
    display: flex;
    @media (min-width: $breakpoint-md) {
      display: table-row;
      &:last-of-type {
        td {
          &:first-of-type {
            border-bottom-left-radius: 4px;
          }
          &:last-of-type {
            border-bottom-right-radius: 4px;
          }
        }
      }
    }
  }

  &__cell-desktop {
    display: none;
    @media (min-width: $breakpoint-md) {
      display: table-cell;
    }
  }

  &__cell-mobile {
    display: flex;
    border-right: 0px !important;
    width: 50%;
    align-items: center;
    justify-content: center;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  &__mobile-tabs {
    display: block;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  &__logo {
    width: 50%;
    @media (min-width: $breakpoint-md) {
      width: auto;
    }
  }

  &__stage {
    cursor: pointer;
    @media (min-width: $breakpoint-md) {
      cursor: default;
      pointer-events: none;
    }

    &:before {
      display: block;
      content: '';
      height: 2px;
      width: 100%;
      background: transparent;
      margin-bottom: 12px;
      transition: background-color 0.3s ease;
      @media (min-width: $breakpoint-md) {
        display: none;
      }
    }

    &.stages-table__stage--active {
      &:before {
        background: $color-text-link-100;
      }
    }
  }

  &__icon {
    color: $color-primary-200;
    :deep .slp-icon--size-md {
      height: $spacing-24;
      width: $spacing-24;
    }
    .stages-table__main-competitor & {
      border: 2px solid $color-primary-200;
      border-radius: 100%;
    }
  }

  &__heading {
    padding: $spacing-32 0 $spacing-48 0;
    position: relative;
    z-index: 1000;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-64 0;
    }
  }

  &__disclaimer {
    padding: $spacing-32 0 0 0;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-96 0 0 0;
    }
  }

  &__italic {
    font-style: italic;
  }

  &__stage-name {
    text-transform: capitalize;
  }
  &__blocker {
    position: relative;

    &__div {
      height: 1px;
      display: block;
      position: relative;
      bottom: 0;
      background: $color-secondary-200;
      &::before {
        content: '';
        width: calc(100% + 100px);
        height: 160px;
        background: $color-secondary-200;
        position: absolute;
        left: -50px;
        bottom: -100px;
        box-shadow: 0px 0px 20px 20px $color-secondary-200;
      }
    }
  }
}
</style>
